'use strict';

var _handleActions;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefetchError = exports.prefetchSuccess = exports.prefetchInit = undefined;

var _reduxActions = require('redux-actions');

var _constants = require('./constants.js');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _constants.REDUX_PREFETCH_INIT, function (state, action) {
  return _extends({}, state, _defineProperty({}, action.payload.namespace + '_fetching', true));
}), _defineProperty(_handleActions, _constants.REDUX_PREFETCH_SUCCESS, function (state, action) {
  return _extends({}, state, _defineProperty({}, action.payload.namespace + '_fetching', _extends({}, action.payload)));
}), _defineProperty(_handleActions, _constants.REDUX_PREFETCH_ERROR, function (state, action) {
  return _extends({}, state, _defineProperty({}, action.payload.namespace + '_fetching', _extends({}, action.payload)));
}), _handleActions), initialState);
var prefetchInit = exports.prefetchInit = (0, _reduxActions.createAction)(_constants.REDUX_PREFETCH_INIT, function (namespace, action) {
  return {
    namespace: namespace,
    promise: action
  };
});

var prefetchSuccess = exports.prefetchSuccess = (0, _reduxActions.createAction)(_constants.REDUX_PREFETCH_SUCCESS, function (namespace, result) {
  return {
    namespace: namespace,
    data: result
  };
});

var prefetchError = exports.prefetchError = (0, _reduxActions.createAction)(_constants.REDUX_PREFETCH_ERROR, function (namespace, result) {
  return {
    namespace: namespace,
    error: result
  };
});